unit fMain;

interface

uses
  Windows, Forms, StdCtrls, Classes, Controls;

type

  TArrayOfInteger = array of Integer;

  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  protected
    function GetSample(Range, Count: Int64): TArrayOfInteger;
    function ABS_ARRAY(A: TArrayOfInteger): TArrayOfInteger;
    function SumOf(A: TArrayOfInteger): Integer; overload;
    function Show(A: TArrayOfInteger): string;
    function Extract(A: TArrayOfInteger; NumType: Integer): TArrayOfInteger;
    function Append(A: TArrayOfInteger; V: Integer): TArrayOfInteger;
    function NumStr(V: Integer; Signed: Boolean=True): string;
    function FindSignBits(T: TArrayOfInteger; Sum: Int64; var SignBits: Int64): Boolean;
    function GetPNElements(T: TArrayOfInteger; SignBits: Int64; PN: Integer): TArrayOfInteger;
  end;

var
  Form1: TForm1;

implementation

uses SysUtils, Math;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
end;

function TForm1.NumStr(V: Integer; Signed: Boolean): string;
begin
  Result := IntToStr(V);
  if Signed and (V >= 0) then
    Result := '+' + Result;
end;

function TForm1.GetSample(Range, Count: Int64): TArrayOfInteger;
var
  I: Integer;
begin
  //üƲͼƦC
  SetLength(Result, Count);
  for I := 0 to Count-1 do
  begin
    Result[I] := Random(Range);
    if Random(1000) mod 2 = 0 then
      Result[I] := Result[I] * -1;
  end;
end;

function TForm1.SumOf(A: TArrayOfInteger): Integer;
var
  I: Integer;
begin
  Result := 0;
  I := 0;
  while I < Length(A) do
  begin
    Inc(Result, A[I]);
    Inc(I);
  end;
end;

function TForm1.Show(A: TArrayOfInteger): string;
var
  S: string;
  I: Integer;
begin
  if Length(A) = 0 then Result := '{}'
  else begin
    S := '{ ';
    for I := 0 to Length(A)-1 do
      S := S + NumStr(A[I]) + ', ';
    Result := Copy(S, 1, Length(S)-2) + ' }';
  end;
end;

function TForm1.Append(A: TArrayOfInteger; V: Integer): TArrayOfInteger;
begin
  SetLength(Result, Length(A)+1);
  Move(Pointer(A)^, Pointer(Result)^, Length(A) * SizeOf(Integer));
  Result[Length(Result)-1] := V;
end;

function TForm1.ABS_ARRAY(A: TArrayOfInteger): TArrayOfInteger;
var
  I: Integer;
begin
  SetLength(Result, Length(A));
  I := 0;
  while I < Length(A) do
  begin
    Result[I] := ABS(A[I]);
    Inc(I);
  end;
end;

function TForm1.Extract(A: TArrayOfInteger; NumType: Integer): TArrayOfInteger;
var
  I, J: Integer;
begin
  //NumType = 0: tƼƦC, 1: ƼƦC
  Result := nil;
  if (NumType in [0,1]) and (Length(A)>0) then
  begin
    J := 0;
    SetLength(Result, Length(A));//B:ƶX
    try
      for I := 0 to Length(A)-1 do
      begin
        if ((A[I]>=0) and (NumType=1)) or
           ((A[I]<0)  and (NumType=0)) then
        begin
          Result[J] := A[I];
          Inc(J);
        end;
      end;
    finally
      SetLength(Result, J);
    end;
  end;
end;

function TForm1.FindSignBits(T: TArrayOfInteger; Sum: Int64;
  var SignBits: Int64): Boolean;
var
  I, J, Count: Integer;
  K, CheckSum: Int64;
begin
  SignBits := 0;//SignBits 笰p⪺
  Result := False;
  T := ABS_ARRAY(T);                    //ȼƦC
  Count := Round(Power(2, Length(T)));  //iզXƥ
  for I := 0 to Count-1 do
  begin
    K := I;
    CheckSum := 0;
    for J := 0 to Length(T)-1 do//Iterate All Element
    begin
      if K and $1 = 0 then CheckSum := CheckSum - ABS(T[J])
      else                 CheckSum := CheckSum + ABS(T[J]);
      K := K shr 1;
    end;
    if CheckSum = Sum then
    begin
      SignBits := I;
      Result := True;
      Break;
    end;

  end;
end;

function TForm1.GetPNElements(T: TArrayOfInteger; SignBits: Int64; PN: Integer): TArrayOfInteger;
var
  I, J, Sign: Integer;
begin
  //PN= 0:, 1: t
  Result := nil;
  if (PN in [0,1]) and (Length(T)>0) then
  begin
    J := 0;
    T := ABS_ARRAY(T);
    SetLength(Result, Length(T));
    try
      if PN = 1 then Sign := +1 else Sign := -1;
      for I := 0 to Length(T)-1 do
      begin
        if SignBits and $01 = PN then
        begin
          Result[J] := T[I] * Sign;
          Inc(J);
        end;
        SignBits := SignBits shr 1;
      end;
    finally
      SetLength(Result, J);
    end;
  end;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var
  StartTick: Cardinal;
  SignBits: Int64;
  A, B, C, T, P, N: TArrayOfInteger;
begin
  StartTick := GetTickCount;
  B := nil; C := nil;
  P := nil; N := nil;
  A := GetSample(MaxInt div 8, 10); //(Range, Count)
  T := ABS_ARRAY(A);                //NƦC, 䥿.
  try
    ListBox1.Items.Add('========================================================');
    ListBox1.Items.Add('ƦCˡ@A: ' + Show(A) + '=' + IntToStr(SumOf(A)));
    ListBox1.Items.Add('ƦCT: ' + Show(T) + '=' + IntToStr(SumOf(T)));
    ListBox1.Items.Add('--------------------------------------------------------');
    //ѤwM, PȼƦChpҦiƦCM, Ǧ^ƦC SignBits
    if FindSignBits(T, SumOf(A), SignBits) then
    begin
      B := Extract(A, 1);//B:ƶX
      C := Extract(A, 0);//C:tƶX
      ListBox1.Items.Add('Done!');
      ListBox1.Items.Add('[ƦCB: ' + Show(B) + '=' + IntToStr(SumOf(B)));
      ListBox1.Items.Add('ƦCC: ' + Show(C) + '=' + IntToStr(SumOf(C)));
      ListBox1.Items.Add('--------------------------------------------------------');
      P := GetPNElements(T, SignBits, 1);
      N := GetPNElements(T, SignBits, 0);
      ListBox1.Items.Add('ƦCT: ' + Show(T) + '=' + IntToStr(SumOf(T)));
      ListBox1.Items.Add('B⤧t   : ' + Format('%8.8X', [SignBits]));
      ListBox1.Items.Add('B⤧[ƦCP: ' + Show(P) + '=' + IntToStr(SumOf(P)));
      ListBox1.Items.Add('B⤧ƦCN: ' + Show(N) + '=' + IntToStr(SumOf(N)));
      ListBox1.Items.Add('BɶTick(ms):' + IntToStr(GetTickCount-StartTick));
      ListBox1.Items.Add('========================================================');
    end;
  finally
    A := nil; T := nil;
    B := nil; C := nil;
    P := nil; N := nil;
  end;
end;


end.
